%% get depth for central camera and normalized image image directions
%
% Usage:
%   d = calc_depth_central_xs(X,P,xs)
%
%   X  - 4-vector of  3D point
%   P  - 3x4 projection matrix
%   xs - 3x1-vector of direction of camera, normalized
%
%   d - depth, is positive if point is in front of camera 
%                             (similar direction as xs)
%
% Wolfgang Frstner 4/2013
% wfoerstn@uni-bonn.de 
%
% See also calc_depth_central_x, calc_depth_central_xs_RZ, calc_depth_perspective

function d = calc_depth_central_xs(X,P,xs)

[~,R,Z] = calc_KRZ_from_P(P,1);

d = xs'*R*(X(1:3)/X(4)-Z);
