%% get depth for central camera given extrinsic parameters explicite 
% and normalized image image directions
%
% Usage:
%   d = calc_depth_central_xs(X,R,Z,xs)
%
%   X  - 4-vector of 3D point
%   R  - 3x3 matrix of rotation
%   Z  - 3x1-vector of projection centre
%   xs - 3x1-vector of direction, normalized
%
%   d - depth, is positive if point is in front of camera
%
% Wolfgang Frstner 4/2013
% wfoerstn@uni-bonn.de 
%
% See also calc_depth_central_x, calc_depth_central_xs, calc_depth_perspective

function d = calc_depth_central_xs_RZ(X,R,Z,xs)

d = xs'*R*(X(1:3)/X(4)-Z);
