%% Covariance matrix of homogeneous homography, 
% wrt h = vec(H)
%
% Chh = sugr_get_CovM_homogeneous_Homography_2D(H)
% Jrh = Jacobian r -> h
%
% Wolfgang Frstner
% wfoerstn@uni-bonn.de
%
% wf 2/2011

function [Chh,Jrh] = sugr_get_CovM_homogeneous_Homography_2D(H)

Ht  = H.H';      
Jrh = [Ht(1,1)*eye(3), ...
       Ht(1,2)*eye(3), ...
       Ht(1,3)*eye(3); ...        
       Ht(2,1)*eye(3), ...
       Ht(2,2)*eye(3), ...
       Ht(2,3)*eye(3); ...
       Ht(3,1)*eye(3), ...
       Ht(3,2)*eye(3), ...
       Ht(3,3)*eye(3)] ...
       * [eye(8); [-1,0,0,0,-1,0,0,0]]; % Jacobian h -> hr , 9 x 8   
Chh = Jrh * H.Crr * Jrh';               % CovM of homogeneous vector vec H
         